global['debug'] = (process.env.NODE_ENV === 'debug') ? true : false;
global['__dirname'] = __dirname;

/**
 * load modules
 */
const load = (name) => {
	return require(__dirname+'/bin/'+name+'/module');
};

// environment variable check
const env_vars = ["APP_ID", "APP_SECRET"];
let env_missing = false;
env_vars.forEach((el) => {
	if(typeof process.env[el] == 'undefined') {
		console.error("environment variable "+el+" is not set");
		env_missing = true;
	}
});
if(env_missing) process.exit();

global['logs'] = load('logs'); // log handler

const webServer = load('web'); // web server

// start web server
webServer.start();
